﻿function displayHideButtons(isMouseIn){
   bg_menu.visible=isMouseIn;
   b_fs.visible = (isMouseIn && (_wmp.PlayState ==2 || _wmp.PlayState ==3));//2-paused, 3-playing
   WMPOnPlayStateChange();//final display decision
   b_netcon.opacity=0;
}

function WMPOnPlayStateChange(){
   if(_wmp.PlayState == 1 || _wmp.PlayState == 10){//1-stopped, 10-ready
     bg_menu.visible=true;
     b_fs.visible=false;
   }
}

function playInFullScreen(){
  if(_wmp.PlayState ==2 || _wmp.PlayState ==3){
	_wmp.fullScreen=true;
   }
}

//populate online channels List 
function populateOnlineList(){
  objXml = new XMLHttpRequest();
  try {
    objXml.open("GET",channelsListUrl, false);
    objXml.onreadystatechange = handleResponse;
    objXml.send();
  } catch (e) {
    return null;
  }
  
function handleResponse() {
          if (objXml.readyState == 1)
              b_netcon.opacity=0; 
	  // Verify that the download completed
	  if (objXml.readyState != 4)
	    return null;
	  // Verify that the download was successful
	  if (objXml.status != 200) {
            b_netcon.opacity=255;
	    objXml = null;
	    return null;
	  }
        respText = objXml.responseText;
	if(respText != null){
        tvChannelsList = new Array();
        radioChannelsList = new Array();
        moviesList = new Array();
		populated=true;
		var msg= respText.split("\n");
		for(cnt=0;cnt<msg.length;cnt++){
			if(msg[cnt].indexOf("~T~")==0){
			   tvChannelsList[tvChannelsList.length]=msg[cnt];
			}else if(msg[cnt].indexOf("~S~")==0){
			   radioChannelsList[radioChannelsList.length]=msg[cnt];
			}else if(msg[cnt].indexOf("~M~")==0){
			   moviesList[moviesList.length]=msg[cnt];
			}
		}
                tvChannelsList.sort();
                radioChannelsList.sort();
	        moviesList.sort();
		lastLoadedTime= new Date();
		objXml=null;
       }
  }
}

function openList(listNum) {
  refreshList(listNum);
  var htmlDetailsView = new DetailsView();
  htmlDetailsView.html_content = true;
  var detailsHtmlContent = getDetailsHtml(listNum);
  htmlDetailsView.setContent("", undefined, detailsHtmlContent, false, 0);

  var externalObject = new Object();
  externalObject.FunctionsForDetailsView = FunctionsForDetailsView;
  htmlDetailsView.external = externalObject;

  pluginHelper.showDetailsView(htmlDetailsView, DETAILS_VIEW_TITLE,
  gddDetailsViewFlagToolbarOpen, null);
}

function refreshList(listNum){
 if(listNum == LIST_SONGS || listNum == LIST_MOVIES_VIDEOS){
     queryMediaFiles(listNum);
  }else if( listNum == LIST_O_TV || listNum == LIST_O_RADIO || listNum == LIST_O_MOVIES){
	  if(!populated){
	    populateOnlineList();
	  }
	  // refresh list everyday.
	  if(((new Date()).getTime()-lastLoadedTime.getTime()) > 24*60*60*1000){
	       populateOnlineList();    
	    }
   }
}

function FunctionsForDetailsView(){

 this.onPlayClick = function onPlayClick(namesAndUrls) {
	if(namesAndUrls != null && namesAndUrls.length > 0){
	  var plist = _wmp.newPlaylist("MyPlayList", "");
	  nowPlayingList=namesAndUrls;
          recentlyPlayedList= nowPlayingList.concat(recentlyPlayedList);
          if(recentlyPlayedList.length > rpMaxSize) recentlyPlayedList.splice(rpMaxSize,recentlyPlayedList.length-rpMaxSize);
          options("recentlyPlayedList")= recentlyPlayedList.join(SEPRTR);

	  for(i=0;i<nowPlayingList.length;i++){
	   plist.appendItem(_wmp.newMedia(nowPlayingList[i].substring(nowPlayingList[i].indexOf(NU_SEPRTR)+NU_SEPRTR.length)));
	  }
	  _wmp.currentPlaylist = plist;
	  _wmp.controls.play();
	  pluginHelper.CloseDetailsView();
	  displayHideButtons(false);
	}
     }

 this.getFilteredOptions=function getFilteredOptions(filterStr,listNum){
         currentChannelsList = getProperList(listNum);         
         if(currentChannelsList.length == 0){
            refreshList(listNum);
            currentChannelsList = getProperList(listNum);
            if(currentChannelsList.length == 0) return currentChannelsList;
         }
         if(filterStr == null || filterStr == ''){
           return currentChannelsList;
          }         
	 var toReturn=new Array();       
	  if(currentChannelsList.length >0){
		filterStr = filterStr.toLowerCase();
                //searching for all words
                filterStr = filterStr.split(" ");                
		var itemName;
                var toAdd=true;
		for(i=0;i<currentChannelsList.length;i++){
		   itemName=currentChannelsList[i].substring(3,currentChannelsList[i].indexOf(NU_SEPRTR));
                   if(itemName != null){
                      itemName=itemName.toLowerCase();
                      toAdd=true;
                      for(j=0;j<filterStr.length;j++){
                          if(filterStr[j] == " ") continue;
		          if(itemName.indexOf(filterStr[j]) < 0) {//all the words should be there
                            toAdd=false;
                            break;
                          }
		      }
                    if(toAdd) toReturn[toReturn.length]=currentChannelsList[i];
                   }
		}
	  }
	 return toReturn;  
	}

 this.addRemoveFav=function addRemoveFav(namesAndUrls,isAdd){
	if(namesAndUrls != null && namesAndUrls.length >0 ){
          var favStr=favList.join(SEPRTR);
	  for(i=0;i<namesAndUrls.length;i++){
             if(isAdd && favStr.indexOf(namesAndUrls[i]) < 0){            
                favList[favList.length]=namesAndUrls[i];
	     }else if(!isAdd && favStr.indexOf(namesAndUrls[i]) >= 0){
                for(j=0;j<favList.length;j++){
                   if(favList[j] == namesAndUrls[i]) favList.splice(j,1);
                }
             }
          }
         favList.sort();
         options("favList")=favList.join(SEPRTR);
	}
      }

 this.getSeparator=SEPRTR;
 this.getNUSeparator=NU_SEPRTR;
 this.getFilesPerPage=options.GetValue("filesPerPage");
}
function getProperList(listNum){
	 switch(listNum){
            case LIST_NOW : currentChannelsList=nowPlayingList;break;
            case LIST_RECENT : currentChannelsList=recentlyPlayedList;break;
	    case LIST_FAV : currentChannelsList=favList;break;
	    case LIST_SONGS : currentChannelsList=localSongsList;break;
	    case LIST_MOVIES_VIDEOS : currentChannelsList=localMoviesList;break;
	    case LIST_O_TV : currentChannelsList=tvChannelsList;break;
	    case LIST_O_RADIO : currentChannelsList=radioChannelsList;break;
	    case LIST_O_MOVIES : currentChannelsList=moviesList;break;
            case LIST_ALL : currentChannelsList=localSongsList.concat(localMoviesList).concat(tvChannelsList).concat(radioChannelsList).concat(moviesList);break;
	  }
         if(currentChannelsList == null ) currentChannelsList = new Array();
         return currentChannelsList;
}
function getPlayListOptions(listNum){
         //initialize
	if(plNames.length == 0 || pls.length == 0){
	    plNames=new Array("Now Playing","Recently Played","Favorites", "My Songs", "My Movies", "Online TV Channels", "Online Radio Channels", "Online Movies","All Media Files");
	    pls=new Array(nowPlayingList,recentlyPlayedList,favList,localSongsList,localMoviesList,tvChannelsList,radioChannelsList,moviesList,new Array()); 
	 }
	var opHtml="";
	for(i=0;i<plNames.length;i++){
           if(listNum == i)
	      opHtml += "<OPTION selected value='"+i+"'>"+plNames[i]+"</OPTION>";
           else
              opHtml += "<OPTION value='"+i+"'>"+plNames[i]+"</OPTION>";
	}
	return opHtml;
}

function getDetailsHtml(listNum){
return "<html><head><style>body{background: #3b5f7b;color: orange;font-family: Arial,sans-serif; FONT: bolder 11px Verdana, Geneva, Arial, Helvetica, sans-serif;} "+
"    td {font-family:verdana, Arial, Helvetica, sans-serif; font-size: 8pt; font-weight: normal; background: lightblue;color:black} "+
"    .headerFile {background: silver;color: black; FONT: bolder 12px Verdana, Geneva, Arial, Helvetica, sans-serif;} "+
"	.input_button {FONT: bolder 11px Verdana, Geneva, Arial, Helvetica, sans-serif; COLOR: #ffffff; BACKGROUND-COLOR: #da0032; width:40px;} "+
"	.divplay {position: absolute; left: 5px; top: 5px;} "+
"	.divfavplus {position: absolute; left: 48px; top: 5px; width: 10px; height: 10px;} "+
"	.divfavminus {position: absolute; left: 92px; top: 5px; width: 10px; height: 10px;} "+
"	.divplaylist {position: absolute; left: 5px; top: 27.5px; width:150px;} "+
"	.divqsearch {position: absolute; left: 160px; top: 27.5px;} "+
"	.divinfo {position: absolute;left: 270px; top: 27.5px; z-index: 1; width: 125px;background: #3b5f7b; padding: .3em;} "+
"    .qtbox { font-family:verdana, Arial, Helvetica, sans-serif; font-size: 8pt; font-weight: normal; background: #CCFFCC; } "+
"	.divfiles {overflow-y:auto; scrollbar-face-color: #CCCCFF; position: absolute; left: 5px; top: 50px; font-family:verdana, Arial, Helvetica, sans-serif; font-size: 8pt; font-weight: normal;} "+
"	.selboxpl { font-family:verdana, Arial, Helvetica, sans-serif; font-size: 8pt; font-weight: normal; background: #FFCC99;width:150px} "+
"</style></head><body onload='searchList(0,1);'> "+
"<div class=divplay><input type='button' class=input_button value='Play' onClick='playSelectedFiles();' onMouseOver='WT(2);' onMouseOut='WT(0);'/> "+
"</div><div class=divfavplus> "+
"<input type='button' class=input_button value='+Fav' onClick='AddRemoveToFav(true);' onMouseOver='WT(3);' onMouseOut='WT(0);'/> "+
"</div><div class=divfavminus> "+
"<input type='button' class=input_button value='-Fav' onClick='AddRemoveToFav(false);' onMouseOver='WT(4);' onMouseOut='WT(0);'/> "+
"</div><div class=divplaylist> "+
"<SELECT id=pl onChange='searchList(0,1);' class=selboxpl > " + getPlayListOptions(listNum) + " </SELECT> "+
"</div><div class=divqsearch> "+
"<input id='st' class=qtbox size=15 type='text' value='Quick Search' onFocus=\"if(this.value =='Quick Search') this.value=''\" onBlur=\"if(this.value =='') this.value='Quick Search'\" onkeypress='searchList(event.keyCode,1);' /> "+
"</div><div id=infoId  class=divinfo>Search Results "+
"</div><div id=filesId class=divfiles></div> "+
"<script language='Javascript'> "+
"document.oncontextmenu=new Function(\"return false\"); "+
"var extFn = new window.external.FunctionsForDetailsView(); "+
"var seprtr=extFn.getSeparator; "+
"var nuseprtr=extFn.getNUSeparator; "+
"var fpp=extFn.getFilesPerPage; "+
"var searchResults = new Array(); "+
"function getPln(){return document.getElementById('pl').options.selectedIndex;} "+
"function playSelectedFiles(){ "+
"      var chBoxes=document.getElementsByName('chBox'); "+
"	  var namesAndUrls= new Array(); "+
"	  for(i=0;i<chBoxes.length;i++) { "+
"	       if(chBoxes[i].checked) namesAndUrls.push(chBoxes[i].value);			 "+
"	  } "+
"	  if(namesAndUrls.length > 0 ) extFn.onPlayClick(namesAndUrls); "+
"	  else WT(-1);	   "+
"	  return false; "+
"} "+
"function checkAll(isChecked){ "+
"  var chBoxes=document.getElementsByName('chBox'); "+
"  for(i=0;i<chBoxes.length;i++) { "+
"    chBoxes[i].checked=isChecked; "+
"  } "+
"} "+
"function searchList(kcd,pageNum){ "+
"  var sStr=document.getElementById('st').value; "+
"  if(sStr == null || sStr=='Quick Search') sStr='';   "+
"  if(kcd>31 && kcd<127){ "+
"    sStr +=String.fromCharCode(kcd); "+
"	} "+
"  searchResults=extFn.getFilteredOptions(sStr,getPln()); "+
"  if(searchResults == null) searchResults=new Array(); "+
"  var divfilesHTML = '<table cellspacing=0 cellpadding=0><tr><td nowrap style=\"background: #3b5f7b;\">' + getPagesHtml(pageNum) + '</td></tr></table>'; "+
"  divfilesHTML += '<table border=1 cellspacing=0 cellpadding=0><tr><td class=headerFile><input type=checkbox onClick=checkAll(this.checked);></td><td class=headerFile> Name </td>'; "+
"  if(getPln() <=4) divfilesHTML +='<td class=headerFile>Artist</td><td class=headerFile>Album</td><td class=headerFile>Type</td></tr>'; "+
"  else divfilesHTML +='</tr>'; "+
"  for(i=(pageNum-1)*fpp; i< pageNum*fpp; i++){     "+
"  	if(i >= searchResults.length) break; "+
"	divfilesHTML +='<tr><td><input type=checkbox name=chBox value=\"' + searchResults[i]+'\"></td>'; "+
"	if(searchResults[i].indexOf('~:') < 0){ "+
"		 divfilesHTML += '<td nowrap>'+ searchResults[i].substring(3,searchResults[i].indexOf(nuseprtr)) + '</td>'; "+
"		 if(getPln() <=4) divfilesHTML += '<td>-</td><td>-</td><td>-</td></tr>';  "+
"		 else divfilesHTML +='</tr>'; "+
"	}else{ "+
"	 divfilesHTML += '<td nowrap>'+ searchResults[i].substring(3,searchResults[i].indexOf('~:')) + '</td>'; "+
"		 if(getPln() <=4) { "+
"		 divfilesHTML += '<td nowrap>'+searchResults[i].substring(searchResults[i].indexOf('~:')+2,searchResults[i].indexOf(':~'))+'</td>'; "+
"		 divfilesHTML += '<td nowrap>'+searchResults[i].substring(searchResults[i].indexOf('~!')+2,searchResults[i].indexOf('!~'))+'</td>'; "+
"		 divfilesHTML += '<td nowrap>'+searchResults[i].substring(searchResults[i].indexOf('~*')+2,searchResults[i].indexOf('*~'))+'</td></tr>'; "+
"		}else divfilesHTML +='</tr>'; "+
"	} "+
"  } "+
"  divfilesHTML +='</table>'; "+
"  document.getElementById('filesId').innerHTML=divfilesHTML; "+
"  WT(0); "+
"} "+
"function getPagesHtml(pageNum){ "+
"  var pagesHtmlVal=''; "+
"  var totalPages=Math.ceil(searchResults.length/fpp); "+
"  if(totalPages > 0){ "+
"      pagesHtmlVal='<font size=2 color=orange> Page:  </font>'; "+
"	  for(i=1;i<=totalPages;i++){ "+
"		 if(i==pageNum) pagesHtmlVal += '<a style=\"color: black;\">'+ i + '   </a>'; "+
"		 else pagesHtmlVal += '<a style=\"cursor: hand; color: orange;\" onClick=searchList(0,'+i+')>'+ i + '   </a>'; "+
"	   } "+
"   } "+
"  return pagesHtmlVal; "+
"} "+
"function AddRemoveToFav(isAdd){ "+
"  var favListAddRemove=new Array(); "+
"  var chBoxes=document.getElementsByName('chBox'); "+
"  for(i=0;i<chBoxes.length;i++) { "+
"     if(chBoxes[i].checked) favListAddRemove.push(chBoxes[i].value); "+
"  } "+
"  if(favListAddRemove.length > 0){ "+
"	  extFn.addRemoveFav(favListAddRemove,isAdd); "+
"	  if(document.getElementById('pl').options.selectedIndex == 2) searchList(0,1); "+
"	  WT(1); "+
"  }else WT(-1); "+
"   return false; "+
"} "+
"function WT(num){ "+
"  var srd = document.getElementById('infoId'); "+
"  if(num == -1) srd.innerHTML = 'No files selected. Select files from the list below.' ; "+
"  else if(num == 0) srd.innerHTML = searchResults.length +' items' ; "+
"  else if(num == 1) srd.innerHTML = 'Done ...' ; "+
"  else if(num == 2) srd.innerHTML = 'Play selected files.'; "+
"  else if(num == 3) srd.innerHTML = 'Add selected files to the Favorites playlist' ; "+
"  else if(num == 4) srd.innerHTML = 'Remove selected files from the Favorites playlist' ; "+
"} "+
"</script></body></html> ";
}